diff -uwbBpr libfloat/softfloat/bits32/softfloat.c SoftFloat-2a/softfloat/bits32/softfloat.c
--- libfloat/softfloat/bits32/softfloat.c	Wed Sep 15 16:18:51 1999
+++ SoftFloat-2a/softfloat/bits32/softfloat.c	Mon Sep 20 11:46:53 1999
@@ -1680,10 +1680,10 @@ static float64 addFloat64Sigs( float64 a
 /*
 -------------------------------------------------------------------------------
 Returns the result of subtracting the absolute values of the double-
-precision floating-point values `a' and `b'.  If `zSign' is true, the
+precision floating-point values `a' and `b'.  If `zSign' is 1, the
 difference is negated before being returned.  `zSign' is ignored if the
 result is a NaN.  The subtraction is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 static float64 subFloat64Sigs( float64 a, float64 b, flag zSign )
@@ -1766,7 +1766,7 @@ static float64 subFloat64Sigs( float64 a
 -------------------------------------------------------------------------------
 Returns the result of adding the double-precision floating-point values `a'
 and `b'.  The operation is performed according to the IEC/IEEE Standard for
-Binary Floating-point Arithmetic.
+Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_add( float64 a, float64 b )
@@ -1788,7 +1788,7 @@ float64 float64_add( float64 a, float64 
 -------------------------------------------------------------------------------
 Returns the result of subtracting the double-precision floating-point values
 `a' and `b'.  The operation is performed according to the IEC/IEEE Standard
-for Binary Floating-point Arithmetic.
+for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_sub( float64 a, float64 b )
@@ -1810,7 +1810,7 @@ float64 float64_sub( float64 a, float64 
 -------------------------------------------------------------------------------
 Returns the result of multiplying the double-precision floating-point values
 `a' and `b'.  The operation is performed according to the IEC/IEEE Standard
-for Binary Floating-point Arithmetic.
+for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_mul( float64 a, float64 b )
@@ -1874,8 +1874,8 @@ float64 float64_mul( float64 a, float64 
 /*
 -------------------------------------------------------------------------------
 Returns the result of dividing the double-precision floating-point value `a'
-by the corresponding value `b'.  The operation is performed according to
-the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+by the corresponding value `b'.  The operation is performed according to the
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_div( float64 a, float64 b )
@@ -1958,16 +1958,15 @@ float64 float64_div( float64 a, float64 
 -------------------------------------------------------------------------------
 Returns the remainder of the double-precision floating-point value `a'
 with respect to the corresponding value `b'.  The operation is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_rem( float64 a, float64 b )
 {
     flag aSign, bSign, zSign;
     int16 aExp, bExp, expDiff;
-    bits32 aSig0, aSig1, bSig0, bSig1;
-    bits32 q, term0, term1, term2, allZero, alternateASig0, alternateASig1;
-    bits32 sigMean1;
+    bits32 aSig0, aSig1, bSig0, bSig1, q, term0, term1, term2;
+    bits32 allZero, alternateASig0, alternateASig1, sigMean1;
     sbits32 sigMean0;
     float64 z;
 
@@ -2064,16 +2063,15 @@ float64 float64_rem( float64 a, float64 
 -------------------------------------------------------------------------------
 Returns the square root of the double-precision floating-point value `a'.
 The operation is performed according to the IEC/IEEE Standard for Binary
-Floating-point Arithmetic.
+Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 float64 float64_sqrt( float64 a )
 {
     flag aSign;
     int16 aExp, zExp;
-    bits32 aSig0, aSig1, zSig0, zSig1, zSig2;
+    bits32 aSig0, aSig1, zSig0, zSig1, zSig2, doubleZSig0;
     bits32 rem0, rem1, rem2, rem3, term0, term1, term2, term3;
-    bits32 shiftedRem0, shiftedRem1;
     float64 z;
 
     aSig1 = extractFloat64Frac1( a );
@@ -2098,46 +2096,45 @@ float64 float64_sqrt( float64 a )
         normalizeFloat64Subnormal( aSig0, aSig1, &aExp, &aSig0, &aSig1 );
     }
     zExp = ( ( aExp - 0x3FF )>>1 ) + 0x3FE;
-    shortShift64Left( aSig0 | 0x00100000, aSig1, 11, &aSig0, &aSig1 );
-    zSig0 = estimateSqrt32( aExp, aSig0 ) + 2;
-    if ( 0 <= (sbits32) zSig0 ) zSig0 = 0xFFFFFFFF;
-    if ( aExp & 1 ) shift64Right( aSig0, aSig1, 1, &aSig0, &aSig1 );
+    aSig0 |= 0x00100000;
+    shortShift64Left( aSig0, aSig1, 11, &term0, &term1 );
+    zSig0 = ( estimateSqrt32( aExp, term0 )>>1 ) + 1;
+    if ( zSig0 == 0 ) zSig0 = 0x7FFFFFFF;
+    doubleZSig0 = zSig0 + zSig0;
+    shortShift64Left( aSig0, aSig1, 9 - ( aExp & 1 ), &aSig0, &aSig1 );
     mul32To64( zSig0, zSig0, &term0, &term1 );
     sub64( aSig0, aSig1, term0, term1, &rem0, &rem1 );
     while ( (sbits32) rem0 < 0 ) {
         --zSig0;
-        shortShift64Left( 0, zSig0, 1, &term0, &term1 );
-        term1 |= 1;
-        add64( rem0, rem1, term0, term1, &rem0, &rem1 );
+        doubleZSig0 -= 2;
+        add64( rem0, rem1, 0, doubleZSig0 | 1, &rem0, &rem1 );
     }
-    shortShift64Left( rem0, rem1, 31, &shiftedRem0, &shiftedRem1 );
-    zSig1 = estimateDiv64To32( shiftedRem0, shiftedRem1, zSig0 );
-    if ( ( zSig1 & 0x3FF ) <= 5 ) {
+    zSig1 = estimateDiv64To32( rem1, 0, doubleZSig0 );
+    if ( ( zSig1 & 0x1FF ) <= 5 ) {
         if ( zSig1 == 0 ) zSig1 = 1;
-        mul32To64( zSig0, zSig1, &term1, &term2 );
-        shortShift64Left( term1, term2, 1, &term1, &term2 );
+        mul32To64( doubleZSig0, zSig1, &term1, &term2 );
         sub64( rem1, 0, term1, term2, &rem1, &rem2 );
         mul32To64( zSig1, zSig1, &term2, &term3 );
         sub96( rem1, rem2, 0, 0, term2, term3, &rem1, &rem2, &rem3 );
         while ( (sbits32) rem1 < 0 ) {
             --zSig1;
-            shortShift96Left( 0, zSig0, zSig1, 1, &term1, &term2, &term3 );
+            shortShift64Left( 0, zSig1, 1, &term2, &term3 );
             term3 |= 1;
-            add96(
-                rem1, rem2, rem3, term1, term2, term3, &rem1, &rem2, &rem3 );
+            term2 |= doubleZSig0;
+            add96( rem1, rem2, rem3, 0, term2, term3, &rem1, &rem2, &rem3 );
         }
         zSig1 |= ( ( rem1 | rem2 | rem3 ) != 0 );
     }
-    shift64ExtraRightJamming( zSig0, zSig1, 0, 11, &zSig0, &zSig1, &zSig2 );
+    shift64ExtraRightJamming( zSig0, zSig1, 0, 10, &zSig0, &zSig1, &zSig2 );
     return roundAndPackFloat64( 0, zExp, zSig0, zSig1, zSig2 );
 
 }
 
 /*
 -------------------------------------------------------------------------------
-Returns 1 if the double-precision floating-point value `a' is equal to the
-corresponding value `b', and 0 otherwise.  The comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+Returns 1 if the double-precision floating-point value `a' is equal to
+the corresponding value `b', and 0 otherwise.  The comparison is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float64_eq( float64 a, float64 b )
@@ -2164,9 +2161,9 @@ flag float64_eq( float64 a, float64 b )
 
 /*
 -------------------------------------------------------------------------------
-Returns 1 if the double-precision floating-point value `a' is less than or
-equal to the corresponding value `b', and 0 otherwise.  The comparison is
-performed according to the IEC/IEEE Standard for Binary Floating-point
+Returns 1 if the double-precision floating-point value `a' is less than
+or equal to the corresponding value `b', and 0 otherwise.  The comparison
+is performed according to the IEC/IEEE Standard for Binary Floating-Point
 Arithmetic.
 -------------------------------------------------------------------------------
 */
@@ -2200,7 +2197,7 @@ flag float64_le( float64 a, float64 b )
 -------------------------------------------------------------------------------
 Returns 1 if the double-precision floating-point value `a' is less than
 the corresponding value `b', and 0 otherwise.  The comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float64_lt( float64 a, float64 b )
@@ -2231,10 +2228,10 @@ flag float64_lt( float64 a, float64 b )
 
 /*
 -------------------------------------------------------------------------------
-Returns 1 if the double-precision floating-point value `a' is equal to the
-corresponding value `b', and 0 otherwise.  The invalid exception is raised
-if either operand is a NaN.  Otherwise, the comparison is performed
-according to the IEC/IEEE Standard for Binary Floating-point Arithmetic.
+Returns 1 if the double-precision floating-point value `a' is equal to
+the corresponding value `b', and 0 otherwise.  The invalid exception is
+raised if either operand is a NaN.  Otherwise, the comparison is performed
+according to the IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float64_eq_signaling( float64 a, float64 b )
@@ -2262,7 +2259,7 @@ flag float64_eq_signaling( float64 a, fl
 Returns 1 if the double-precision floating-point value `a' is less than or
 equal to the corresponding value `b', and 0 otherwise.  Quiet NaNs do not
 cause an exception.  Otherwise, the comparison is performed according to the
-IEC/IEEE Standard for Binary Floating-point Arithmetic.
+IEC/IEEE Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float64_le_quiet( float64 a, float64 b )
@@ -2298,7 +2295,7 @@ flag float64_le_quiet( float64 a, float6
 Returns 1 if the double-precision floating-point value `a' is less than
 the corresponding value `b', and 0 otherwise.  Quiet NaNs do not cause an
 exception.  Otherwise, the comparison is performed according to the IEC/IEEE
-Standard for Binary Floating-point Arithmetic.
+Standard for Binary Floating-Point Arithmetic.
 -------------------------------------------------------------------------------
 */
 flag float64_lt_quiet( float64 a, float64 b )
Only in libfloat/softfloat/bits32/templates: CVS
diff -uwbBpr libfloat/softfloat/bits32/timesoftfloat.c SoftFloat-2a/softfloat/bits32/timesoftfloat.c
--- libfloat/softfloat/bits32/timesoftfloat.c	Wed Sep 15 16:18:51 1999
+++ SoftFloat-2a/softfloat/bits32/timesoftfloat.c	Mon Sep 20 11:46:48 1999
@@ -3,10 +3,17 @@
 ===============================================================================
 
 This C source file is part of the SoftFloat IEC/IEEE Floating-point
-Arithmetic Package, Release 2.
+Arithmetic Package, Release 2a.
 
-Written by John R. Hauser.  More information is available through the Web
-page `http://HTTP.CS.Berkeley.EDU/~jhauser/arithmetic/softfloat.html'.
+Written by John R. Hauser.  This work was made possible in part by the
+International Computer Science Institute, located at Suite 600, 1947 Center
+Street, Berkeley, California 94704.  Funding was partially provided by the
+National Science Foundation under grant MIP-9311980.  The original version
+of this code was written as part of a project to build a fixed-point vector
+processor in collaboration with the University of California at Berkeley,
+overseen by Profs. Nelson Morgan and John Wawrzynek.  More information
+is available through the Web page `http://HTTP.CS.Berkeley.EDU/~jhauser/
+arithmetic/SoftFloat.html'.
 
 THIS SOFTWARE IS DISTRIBUTED AS IS, FOR FREE.  Although reasonable effort
 has been made to avoid it, THIS SOFTWARE MAY CONTAIN FAULTS THAT WILL AT
@@ -16,7 +23,7 @@ AND ALL LOSSES, COSTS, OR OTHER PROBLEMS
 
 Derivative works are acceptable, even for commercial purposes, so long as
 (1) they include prominent notice that the work is derivative, and (2) they
-include prominent notice akin to these three paragraphs for those parts of
+include prominent notice akin to these four paragraphs for those parts of
 this code that are retained.
 
 ===============================================================================
@@ -24,30 +31,25 @@ this code that are retained.
 
 #include <stdlib.h>
 #include <stdarg.h>
-#include <time.h>
 #include <string.h>
 #include <stdio.h>
+#include <time.h>
 #include "milieu.h"
 #include "softfloat.h"
 
-char *fail_programName = "timesoftfloat";
-
-void writeFailureV( const char *message, va_list varArgs )
-{
-
-    fprintf( stderr, "%s: ", fail_programName );
-    vfprintf( stderr, message, varArgs );
-    fputs( ".\n", stderr );
-
-}
+enum {
+    minIterations = 1000
+};
 
 void fail( const char *message, ... )
 {
     va_list varArgs;
 
+    fputs( "timesoftfloat: ", stderr );
     va_start( varArgs, message );
-    writeFailureV( message, varArgs );
+    vfprintf( stderr, message, varArgs );
     va_end( varArgs );
+    fputs( ".\n", stderr );
     exit( EXIT_FAILURE );
 
 }
@@ -100,15 +102,16 @@ static void time_a_int32_z_float32( floa
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_int32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_int32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
     }
     endClock = clock();
@@ -126,15 +129,16 @@ static void time_a_int32_z_float64( floa
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_int32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_int32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_int32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_int32 - 1 );
     }
     endClock = clock();
@@ -167,15 +171,16 @@ static void time_a_float32_z_int32( int3
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
     }
     endClock = clock();
@@ -193,15 +198,16 @@ static void time_a_float32_z_float64( fl
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
     }
     endClock = clock();
@@ -219,15 +225,16 @@ static void time_az_float32( float32 fun
     inputNum = 0;
     startClock = clock();
     do {
-        (void) function( inputs_float32[ inputNum ] );
-        ++count;
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void) function( inputs_float32[ inputNum ] );
+    for ( i = count; i; --i ) {
+        function( inputs_float32[ inputNum ] );
         inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
     }
     endClock = clock();
@@ -246,20 +253,19 @@ static void time_ab_float32_z_flag( flag
     inputNumB = 0;
     startClock = clock();
     do {
-        (void)
+        for ( i = minIterations; i; --i ) {
             function(
                 inputs_float32[ inputNumA ], inputs_float32[ inputNumB ] );
-        ++count;
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float32 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void)
+    for ( i = count; i; --i ) {
             function(
                 inputs_float32[ inputNumA ], inputs_float32[ inputNumB ] );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float32 - 1 );
@@ -282,20 +288,19 @@ static void time_abz_float32( float32 fu
     inputNumB = 0;
     startClock = clock();
     do {
-        (void)
+        for ( i = minIterations; i; --i ) {
             function(
                 inputs_float32[ inputNumA ], inputs_float32[ inputNumB ] );
-        ++count;
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float32 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
-        (void)
+    for ( i = count; i; --i ) {
             function(
                 inputs_float32[ inputNumA ], inputs_float32[ inputNumB ] );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float32 - 1 );
@@ -307,6 +312,44 @@ static void time_abz_float32( float32 fu
 
 }
 
+static const float32 inputs_float32_pos[ numInputs_float32 ] = {
+    0x4EFA0000, 0x41D0B328, 0x00000000, 0x3E69A31E,
+    0x2F803EFF, 0x3F800000, 0x17BF8000, 0x674A301A,
+    0x4E010003, 0x7EE3C75D, 0x3D803FE0, 0x3FFEFF00,
+    0x7981F800, 0x431FFFFC, 0x4100C000, 0x3D87EFFF,
+    0x4103FEFE, 0x3C000007, 0x3F01F7FF, 0x4E6C6B5C,
+    0x4187FFFE, 0x458B9F13, 0x4F88007F, 0x5F004007,
+    0x37FFD7FE, 0x7E8001FB, 0x46EFFBFF, 0x31C10000,
+    0x5B428661, 0x33F89B1F, 0x23BFEFFF, 0x537BFFBE
+};
+
+static void time_az_float32_pos( float32 function( float32 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            function( inputs_float32_pos[ inputNum ] );
+            inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        function( inputs_float32_pos[ inputNum ] );
+        inputNum = ( inputNum + 1 ) & ( numInputs_float32 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
 enum {
     numInputs_float64 = 32
 };
@@ -359,19 +402,20 @@ static void time_a_float64_z_int32( int3
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float64[ inputNum ].low;
         a.high = inputs_float64[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float64[ inputNum ].low;
         a.high = inputs_float64[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
     }
     endClock = clock();
@@ -391,19 +435,20 @@ static void time_a_float64_z_float32( fl
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float64[ inputNum ].low;
         a.high = inputs_float64[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float64[ inputNum ].low;
         a.high = inputs_float64[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
     }
     endClock = clock();
@@ -422,19 +467,20 @@ static void time_az_float64( float64 fun
     inputNum = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float64[ inputNum ].low;
         a.high = inputs_float64[ inputNum ].high;
-        (void) function( a );
-        ++count;
+            function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNum = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float64[ inputNum ].low;
         a.high = inputs_float64[ inputNum ].high;
-        (void) function( a );
+        function( a );
         inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
     }
     endClock = clock();
@@ -454,26 +500,27 @@ static void time_ab_float64_z_flag( flag
     inputNumB = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float64[ inputNumA ].low;
         a.high = inputs_float64[ inputNumA ].high;
         b.low = inputs_float64[ inputNumB ].low;
         b.high = inputs_float64[ inputNumB ].high;
-        (void) function( a, b );
-        ++count;
+            function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float64 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float64[ inputNumA ].low;
         a.high = inputs_float64[ inputNumA ].high;
         b.low = inputs_float64[ inputNumB ].low;
         b.high = inputs_float64[ inputNumB ].high;
-        (void) function( a, b );
+        function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float64 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float64 - 1 );
@@ -495,26 +542,27 @@ static void time_abz_float64( float64 fu
     inputNumB = 0;
     startClock = clock();
     do {
+        for ( i = minIterations; i; --i ) {
         a.low = inputs_float64[ inputNumA ].low;
         a.high = inputs_float64[ inputNumA ].high;
         b.low = inputs_float64[ inputNumB ].low;
         b.high = inputs_float64[ inputNumB ].high;
-        (void) function( a, b );
-        ++count;
+            function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float64 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
     } while ( clock() - startClock < CLOCKS_PER_SEC );
-    count += count;
     inputNumA = 0;
     inputNumB = 0;
     startClock = clock();
-    for ( i = count; 0 < i; --i ) {
+    for ( i = count; i; --i ) {
         a.low = inputs_float64[ inputNumA ].low;
         a.high = inputs_float64[ inputNumA ].high;
         b.low = inputs_float64[ inputNumB ].low;
         b.high = inputs_float64[ inputNumB ].high;
-        (void) function( a, b );
+        function( a, b );
         inputNumA = ( inputNumA + 1 ) & ( numInputs_float64 - 1 );
         if ( inputNumA == 0 ) ++inputNumB;
         inputNumB = ( inputNumB + 1 ) & ( numInputs_float64 - 1 );
@@ -524,6 +572,75 @@ static void time_abz_float64( float64 fu
 
 }
 
+static const struct {
+    bits32 high, low;
+} inputs_float64_pos[ numInputs_float64 ] = {
+    { 0x422FFFC0, 0x08000000 },
+    { 0x37E00004, 0x80000000 },
+    { 0x73FD2546, 0x120B7935 },
+    { 0x3FF00000, 0x00000000 },
+    { 0x4E07F766, 0xF09588D6 },
+    { 0x00000000, 0x00000000 },
+    { 0x3FCE0004, 0x00000000 },
+    { 0x0313B60F, 0x0032BED8 },
+    { 0x41EFFFFF, 0xC0002000 },
+    { 0x3FB3C75D, 0x224F2B0F },
+    { 0x7FD00000, 0x004000FF },
+    { 0x212FFF80, 0x00001FFF },
+    { 0x3EE00000, 0x00FE0000 },
+    { 0x00100000, 0x80000004 },
+    { 0x41CFFFFE, 0x00000020 },
+    { 0x40303FFF, 0xFFFFFFFD },
+    { 0x3FD00000, 0x3FEFFFFF },
+    { 0x3FD00000, 0x10000000 },
+    { 0x37FC6B5C, 0x16CA55CF },
+    { 0x413EEB94, 0x0B9D1301 },
+    { 0x47E00200, 0x001FFFFF },
+    { 0x47F00021, 0xFFFFFFFE },
+    { 0x3FFFFFFF, 0xF80000FF },
+    { 0x407FFFFF, 0xE00FFFFF },
+    { 0x001497A6, 0x3740C5E8 },
+    { 0x44BFFFE0, 0x001FFFFF },
+    { 0x16FFDFFE, 0xFFFFFFFF },
+    { 0x403FC000, 0x000001FE },
+    { 0x7FD00000, 0x000001F6 },
+    { 0x06404000, 0x02000000 },
+    { 0x479CEE1E, 0x4F789FE0 },
+    { 0x4237FFFF, 0xFFFFFDFE }
+};
+
+static void time_az_float64_pos( float64 function( float64 ) )
+{
+    clock_t startClock, endClock;
+    int32 count, i;
+    int8 inputNum;
+    float64 a;
+
+    count = 0;
+    inputNum = 0;
+    startClock = clock();
+    do {
+        for ( i = minIterations; i; --i ) {
+            a.low = inputs_float64_pos[ inputNum ].low;
+            a.high = inputs_float64_pos[ inputNum ].high;
+            function( a );
+            inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+        }
+        count += minIterations;
+    } while ( clock() - startClock < CLOCKS_PER_SEC );
+    inputNum = 0;
+    startClock = clock();
+    for ( i = count; i; --i ) {
+        a.low = inputs_float64_pos[ inputNum ].low;
+        a.high = inputs_float64_pos[ inputNum ].high;
+        function( a );
+        inputNum = ( inputNum + 1 ) & ( numInputs_float64 - 1 );
+    }
+    endClock = clock();
+    reportTime( count, endClock - startClock );
+
+}
+
 enum {
     INT32_TO_FLOAT32 = 1,
     INT32_TO_FLOAT64,
@@ -698,7 +815,7 @@ static void
         time_abz_float32( float32_rem );
         break;
      case FLOAT32_SQRT:
-        time_az_float32( float32_sqrt );
+        time_az_float32_pos( float32_sqrt );
         break;
      case FLOAT32_EQ:
         time_ab_float32_z_flag( float32_eq );
@@ -746,7 +863,7 @@ static void
         time_abz_float64( float64_rem );
         break;
      case FLOAT64_SQRT:
-        time_az_float64( float64_sqrt );
+        time_az_float64_pos( float64_sqrt );
         break;
      case FLOAT64_EQ:
         time_ab_float64_z_flag( float64_eq );
@@ -823,7 +940,7 @@ main( int argc, char **argv )
         if ( strcmp( argPtr, "help" ) == 0 ) {
  writeHelpMessage:
             fputs(
-"usage: timesoftfloat [<option>...] <function>\n"
+"timesoftfloat [<option>...] <function>\n"
 "  <option>:  (* is default)\n"
 "    -help            --Write this message and exit.\n"
 "    -nearesteven     --Only time rounding to nearest/even.\n"
Only in libfloat/softfloat/bits64/386-Win32-gcc: CVS
diff -uwbBpr libfloat/softfloat/bits64/386-Win32-gcc/Makefile SoftFloat-2a/softfloat/bits64/386-Win32-gcc/Makefile
--- libfloat/softfloat/bits64/386-Win32-gcc/Makefile	Wed Sep 15 16:18:52 1999
+++ SoftFloat-2a/softfloat/bits64/386-Win32-gcc/Makefile	Mon Sep 20 11:47:11 1999
@@ -1,25 +1,24 @@
 
-PROCESSOR_DIR = ../../../processors
-PROCESSOR_H = $(PROCESSOR_DIR)/386-gcc.h
+PROCESSOR_H = ../../../processors/386-gcc.h
 SOFTFLOAT_MACROS = ../softfloat-macros
-CC = gcc
-CINCLUDES = -I. -I.. -I-
-CFLAGS = -O2
-LINK = gcc
-LFLAGS =
-TIMESOFTFLOAT_EXE = timesoftfloat.exe
 
-ALL: softfloat.o $(TIMESOFTFLOAT_EXE)
+OBJ = .o
+EXE = .exe
+INCLUDES = -I. -I..
+COMPILE_C = gcc -c -o $@ $(INCLUDES) -I- -O2
+LINK = gcc -o $@
+
+ALL: softfloat$(OBJ) timesoftfloat$(EXE)
 
 milieu.h: $(PROCESSOR_H)
 	touch milieu.h
 
-softfloat.o: milieu.h softfloat.h softfloat-specialize $(SOFTFLOAT_MACROS) ../softfloat.c
-	$(CC) $(CINCLUDES) $(CFLAGS) -c ../softfloat.c
+softfloat$(OBJ): milieu.h softfloat.h softfloat-specialize $(SOFTFLOAT_MACROS) ../softfloat.c
+	$(COMPILE_C) ../softfloat.c
 
-timesoftfloat.o: milieu.h softfloat.h ../timesoftfloat.c
-	$(CC) $(CINCLUDES) $(CFLAGS) -c ../timesoftfloat.c
+timesoftfloat$(OBJ): milieu.h softfloat.h ../timesoftfloat.c
+	$(COMPILE_C) ../timesoftfloat.c
 
-$(TIMESOFTFLOAT_EXE): softfloat.o timesoftfloat.o
-	$(LINK) $(LFLAGS) -o $(TIMESOFTFLOAT_EXE) softfloat.o timesoftfloat.o
+timesoftfloat$(EXE): softfloat$(OBJ) timesoftfloat$(OBJ)
+	$(LINK) softfloat$(OBJ) timesoftfloat$(OBJ)
 
